package generator

import "io"
import "github.com/llir/llvm/ir"
import "git.tebibyte.media/sashakoshka/fspl/analyzer"

type generator struct {
	tree   analyzer.Tree
	output io.Writer
	module ir.Module
}

// Generate takes in a semantic tree and writes corresponding LLVM IR to the
// given io.Writer. It returns an error in case there is something wrong with
// the semantic tree that prevents the code generation process from occurring.
func Generate (tree analyzer.Tree, output io.Writer) error {
	return (&generator {
		tree:   tree,
		output: output,
	}).generate()
}

func (this *generator) generate () error {
	
}
